::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: set environment and elevate script in UAC systems
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

@echo off
setlocal

:: change shell codepage to CP1252 in order to support umlauts in path
chcp 1252 > nul

call "..\..\..\shared\setenv.bat"

:: reset shell codepage to CP850
chcp 850 > nul

:: check for UAC and Mandatory Label\High Mandatory Level 

:: without enabledelayedexpansion ERRORLEVEL of nested command couldn't be read
setlocal enabledelayedexpansion

:: test for UAC environment by starting 'whoami.exe', exitcode!=0 if not found
whoami.exe > nul 2>&1

if "!ERRORLEVEL!"=="0" (

   :: test if already elevated by checking group membership
   whoami.exe /groups | find "S-1-16-12288" > nul

   :: relaunch elevated and exit if not running as elevated user                                        
   if not "!ERRORLEVEL!"=="0" ( 
      call "%TC_HOME%\shared\elevate.cmd" cmd /D /C "cd /d """%CD%""" && """%~dpnx0""" %*" & goto :eof
   )
)

endlocal
                                                    
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

:: TRANSCONNECT LDAP Export
:: (c) 2021 by SQL Projekt AG Dresden

set CLASSPATH="%TC_HOME%\server\db\ldap\LDAPExport.jar;%TC_HOME%\server\lib\*;%TC_HOME%\server\lib\ext\*;%TC_HOME%\server\jetty\lib\*;%TC_HOME%\shared\lib\*;%JAVA_HOME%\lib\tools.jar"

:: use minimal memory if just triggering export
set JAVA_OPTS=-Xms32m -Xmx64m

   "%JAVA_HOME%"\bin\java %JAVA_OPTS% -classpath %CLASSPATH% com.sqlag.tc.update.ldapmigration.LDAPExport %TC_HOME% %TC_HOME%\server\db\ldap\ldif\apacheds.ldif

if "%ERRORLEVEL%"=="0" goto success

goto failure

:failure
echo failed
exit /b 1

:success